Index: trunk/LMDZ.MARS/libf/phymars/suaer.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/suaer.F90	(revision 1973)
+++ trunk/LMDZ.MARS/libf/phymars/suaer.F90	(revision 1974)
@@ -6,4 +6,5 @@
                     iaer_dust_conrath,iaer_dust_doubleq,&
                     iaer_dust_submicron,iaer_h2o_ice,&
+                    iaer_stormdust_doubleq,&
                     file_id,radiustab, gvis, omegavis, &
                     QVISsQREF, gIR, omegaIR, &
@@ -153,4 +154,16 @@
 !       Reference wavelength in the infrared:
         longrefir(iaer)=12.1E-6  ! 825cm-1 TES/MGS
+!==================================================================
+        CASE("stormdust_doubleq") aerkind   ! Two-moment scheme for stormdust - radiative properties
+!==================================================================
+!       Visible domain:
+        file_id(iaer,1) = 'optprop_dustvis_TM_n50.dat' !T-Matrix
+!       Infrared domain:
+        file_id(iaer,2) = 'optprop_dustir_n50.dat'     !Mie
+!       Reference wavelength in the visible:
+        longrefvis(iaer)=0.67E-6
+!       If not equal to 0.67e-6 -> change readtesassim accordingly;
+!       Reference wavelength in the infrared:
+        longrefir(iaer)=dustrefir
 !==================================================================
         END SELECT aerkind
Index: trunk/LMDZ.MARS/libf/phymars/surfdat_h.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/surfdat_h.F90	(revision 1973)
+++ trunk/LMDZ.MARS/libf/phymars/surfdat_h.F90	(revision 1974)
@@ -20,4 +20,5 @@
   real,save :: iceradius(2) , dtemisice(2)
   real,save,allocatable :: zmea(:),zstd(:),zsig(:),zgam(:),zthe(:)
+  real,save,allocatable :: hmons(:)
   real,save,allocatable :: z0(:) ! surface roughness length (m)
   real,save :: z0_default ! default (constant over planet) surface roughness (m)
@@ -55,5 +56,6 @@
     allocate(capcal(ngrid))
     allocate(fluxgrd(ngrid))
- 
+    allocate(hmons(ngrid))
+    
   end subroutine ini_surfdat_h
 
@@ -79,4 +81,5 @@
     if (allocated(capcal))      deallocate(capcal)
     if (allocated(fluxgrd))     deallocate(fluxgrd)
+    if (allocated(hmons))       deallocate(hmons)
 
   end subroutine end_surfdat_h
Index: trunk/LMDZ.MARS/libf/phymars/tracer_mod.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/tracer_mod.F90	(revision 1973)
+++ trunk/LMDZ.MARS/libf/phymars/tracer_mod.F90	(revision 1974)
@@ -6,5 +6,5 @@
       integer,save :: nqmx ! initialized in conf_phys
    
-      character*20,allocatable,save ::  noms(:)  ! name of the tracer
+      character*30,allocatable,save ::  noms(:)  ! name of the tracer
       real,allocatable,save :: mmol(:)           ! mole mass of tracer (g/mol-1) 
       real,allocatable,save :: radius(:)   ! dust and ice particle radius (m)
@@ -23,5 +23,5 @@
       real,save :: nuiceco2_sed   ! Sedimentation effective variance of the co2 ice dist.
       real,save :: nuiceco2_ref   ! Effective variance of the co2 ice dist.
-
+      
       real,save :: ccn_factor  ! ratio of nuclei for water ice particles
 
@@ -42,5 +42,7 @@
       integer,save :: igcm_ccn_number ! CCN number mixing ratio
       integer,save :: igcm_dust_submicron ! submicron dust mixing ratio
-    
+      integer,save :: igcm_stormdust_mass   !  storm dust mass mixing ratio
+      integer,save :: igcm_stormdust_number !  storm dust number mixing ratio
+   
       integer,save :: igcm_ccnco2_mass   ! CCN (dust and/or water ice) for CO2 mass mixing ratio
       integer,save :: igcm_ccnco2_number ! CCN (dust and/or water ice) for CO2 number mixing ratio
Index: trunk/LMDZ.MARS/libf/phymars/updatereffrad_mod.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/updatereffrad_mod.F	(revision 1973)
+++ trunk/LMDZ.MARS/libf/phymars/updatereffrad_mod.F	(revision 1974)
@@ -6,5 +6,5 @@
       
       SUBROUTINE updatereffrad(ngrid,nlayer,
-     &                rdust,rice,nuice,
+     &                rdust,rstormdust,rice,nuice,
      &                reffrad,nueffrad,
      &                pq,tauscaling,tau,pplay)
@@ -14,9 +14,11 @@
      &                       igcm_h2o_ice, igcm_ccn_mass, radius,
      &                       igcm_ccn_number, nuice_ref, varian,
-     &                       ref_r0, igcm_dust_submicron
+     &                       ref_r0, igcm_dust_submicron,
+     &                       igcm_stormdust_mass,igcm_stormdust_number
        USE dimradmars_mod, only: nueffdust,naerkind,
      &            name_iaer,
      &            iaer_dust_conrath,iaer_dust_doubleq,
-     &            iaer_dust_submicron,iaer_h2o_ice
+     &            iaer_dust_submicron,iaer_h2o_ice,
+     &            iaer_stormdust_doubleq 
 
        IMPLICIT NONE
@@ -45,28 +47,24 @@
 
 c-----------------------------------------------------------------------
-c     Inputs:
+c     Inputs/outputs:
 c     ------
 
-      INTEGER ngrid,nlayer
+      INTEGER, INTENT(in) :: ngrid,nlayer
 c     Ice geometric mean radius (m)
-      REAL :: rice(ngrid,nlayer)
+      REAL, INTENT(out) :: rice(ngrid,nlayer)
 c     Estimated effective variance of the size distribution (n.u.)
-      REAL :: nuice(ngrid,nlayer)
+      REAL, INTENT(out) :: nuice(ngrid,nlayer)
 c     Tracer mass mixing ratio (kg/kg)
-      REAL pq(ngrid,nlayer,nqmx)
-      REAL rdust(ngrid,nlayer) ! Dust geometric mean radius (m)
-      
-      REAL pplay(ngrid,nlayer) ! altitude at the middle of the layers
-      REAL tau(ngrid,naerkind)
-
-
-c     Outputs:
-c     -------
-
+      REAL, INTENT(in) :: pq(ngrid,nlayer,nqmx)
+      REAL, INTENT(out) :: rdust(ngrid,nlayer) ! Dust geometric mean radius (m)
+      REAL, INTENT(out) :: rstormdust(ngrid,nlayer) ! Dust geometric mean radius (m) 
+      REAL, INTENT(in) :: pplay(ngrid,nlayer) ! altitude at the middle of the layers
+      REAL, INTENT(in) :: tau(ngrid,naerkind)
 c     Aerosol effective radius used for radiative transfer (meter)
-      REAL :: reffrad(ngrid,nlayer,naerkind)
+      REAL, INTENT(out) :: reffrad(ngrid,nlayer,naerkind)
 c     Aerosol effective variance used for radiative transfer (n.u.)
-      REAL :: nueffrad(ngrid,nlayer,naerkind)
-
+      REAL, INTENT(out) :: nueffrad(ngrid,nlayer,naerkind)
+      REAL, INTENT(in) :: tauscaling(ngrid)         ! Convertion factor for qccn and Nccn
+      
 c     Local variables:
 c     ---------------
@@ -85,5 +83,4 @@
       REAL Mo,No                       ! Mass and number of ccn
       REAL rhocloud(ngrid,nlayer)  ! Cloud density (kg.m-3)
-      REAL tauscaling(ngrid)         ! Convertion factor for qccn and Nccn
 
       LOGICAL,SAVE :: firstcall=.true.
@@ -114,4 +111,15 @@
           ENDDO
         ENDIF
+
+        ! updating radius of stormdust particles
+        IF (rdstorm.AND.active) THEN
+          DO l=1,nlayer
+            DO ig=1, ngrid
+              call updaterdust(pq(ig,l,igcm_stormdust_mass),
+     &                 pq(ig,l,igcm_stormdust_number),rstormdust(ig,l))
+              nueffdust(ig,l) = exp(varian**2.)-1.
+             ENDDO
+           ENDDO
+        ENDIF
         
 c       1.2 Water-ice particles
@@ -126,6 +134,6 @@
 
           IF (firstcall) THEN
-            IF (minval(tauscaling).lt.0) tauscaling(:) = 1.e-3 ! default value when non-read in startfi is -1
-            IF (freedust)                tauscaling(:) = 1.    ! if freedust, enforce no rescaling at all
+            !IF (minval(tauscaling).lt.0) tauscaling(:) = 1.e-3 ! default value when non-read in startfi is -1
+            !IF (freedust)                tauscaling(:) = 1.    ! if freedust, enforce no rescaling at all
             firstcall = .false.
           ENDIF
@@ -206,4 +214,14 @@
           ENDDO
 c==================================================================
+        CASE("stormdust_doubleq") aerkind! Two-moment scheme for
+c       stormdust; same distribution than normal dust
+c==================================================================
+          DO l=1,nlayer
+            DO ig=1,ngrid
+              reffrad(ig,l,iaer) = rstormdust(ig,l) * ref_r0
+              nueffrad(ig,l,iaer) = nueffdust(ig,l)
+            ENDDO
+          ENDDO
+c==================================================================
         END SELECT aerkind
       ENDDO ! iaer (loop on aerosol kind)
Index: trunk/LMDZ.MARS/libf/phymars/vdifc_mod.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/vdifc_mod.F	(revision 1973)
+++ trunk/LMDZ.MARS/libf/phymars/vdifc_mod.F	(revision 1974)
@@ -12,12 +12,14 @@
      $                pdudif,pdvdif,pdhdif,pdtsrf,pq2,
      $                pdqdif,pdqsdif,wstar,zcdv_true,zcdh_true,
-     $                hfmax,sensibFlux)
+     $                hfmax,sensibFlux,dustliftday,local_time)
 
       use tracer_mod, only: noms, igcm_dust_mass, igcm_dust_number,
      &                      igcm_dust_submicron, igcm_h2o_vap,
-     &                      igcm_h2o_ice, alpha_lift
+     &                      igcm_h2o_ice, alpha_lift,
+     &                      igcm_stormdust_mass, igcm_stormdust_number
       use surfdat_h, only: watercaptag, frost_albedo_threshold, dryness
       USE comcstfi_h, ONLY: cpp, r, rcp, g
       use turb_mod, only: turb_resolved, ustar, tstar
+      use compute_dtau_mod, only: ti_injection,tf_injection
       IMPLICIT NONE
 
@@ -79,5 +81,7 @@
       real,intent(in) :: pq(ngrid,nlay,nq), pdqfi(ngrid,nlay,nq) 
       real,intent(out) :: pdqdif(ngrid,nlay,nq) 
-      real,intent(out) :: pdqsdif(ngrid,nq) 
+      real,intent(out) :: pdqsdif(ngrid,nq)
+      REAL,INTENT(in) :: dustliftday(ngrid)
+      REAL,INTENT(in) :: local_time(ngrid)
       
 c   local:
@@ -691,5 +695,7 @@
              end do
            else if (doubleq) then
-             do ig=1,ngrid
+             if (dustinjection.eq.0) then !injection scheme 0 (old) 
+             				  !or 2 (injection in CL)
+              do ig=1,ngrid
                if(co2ice(ig).lt.1) then ! pas de soulevement si glace CO2
                  pdqsdif(ig,igcm_dust_mass) =
@@ -698,5 +704,40 @@
      &             -alpha_lift(igcm_dust_number) 
                end if 
-             end do
+              end do
+             elseif(dustinjection.eq.1)then ! dust injection scheme = 1 injection from surface
+              do ig=1,ngrid
+               if(co2ice(ig).lt.1) then ! pas de soulevement si glace CO2
+                IF((ti_injection.LE.local_time(ig)).and.
+     &            	(local_time(ig).LE.tf_injection)) THEN
+     		  if (rdstorm) then !Rocket dust storm scheme
+             	    	pdqsdif(ig,igcm_stormdust_mass) = 
+     &             		-alpha_lift(igcm_stormdust_mass)
+     &				*dustliftday(ig)
+               		pdqsdif(ig,igcm_stormdust_number) = 
+     &             		-alpha_lift(igcm_stormdust_number)
+     &				*dustliftday(ig)
+                 	pdqsdif(ig,igcm_dust_mass)= 0.
+                        pdqsdif(ig,igcm_dust_number)= 0.
+                  else
+                 	pdqsdif(ig,igcm_dust_mass)=
+     &            		-dustliftday(ig)*
+     &            		alpha_lift(igcm_dust_mass)               
+                 	pdqsdif(ig,igcm_dust_number)= 
+     &             		-dustliftday(ig)*
+     &            		alpha_lift(igcm_dust_number)
+		  endif
+             	  if (submicron) then
+                   	pdqsdif(ig,igcm_dust_submicron) = 0.
+                  endif ! if (submicron)
+     		ELSE ! outside dust injection time frame
+                 	pdqsdif(ig,igcm_dust_mass)= 0.
+                        pdqsdif(ig,igcm_dust_number)= 0.
+                 	pdqsdif(ig,igcm_stormdust_mass)= 0.
+                        pdqsdif(ig,igcm_stormdust_number)= 0.
+     		ENDIF
+               
+                end if ! of if(co2ice(ig).lt.1)
+              end do
+             endif ! end if dustinjection
            else if (submicron) then
              do ig=1,ngrid
@@ -723,5 +764,5 @@
 c      Inversion pour l'implicite sur q 
 c       --------------------------------
-        do iq=1,nq
+        do iq=1,nq  !for all tracers including stormdust
           CALL multipl((nlay-1)*ngrid,zkh(1,2),zb0(1,2),zb(1,2))
 
